#include <windows.h>
#include "../include/klesMain.h"

#include "klesBinding.h"
#include <stdio.h>


// OGL-ES 1.1 functions
_GL_ACTIVETEXTURE _glActiveTexture = 0;
_GL_ALPHAFUNC _glAlphaFunc = 0;
_GL_ALPHAFUNCX _glAlphaFuncx = 0;
_GL_BINDTEXTURE _glBindTexture = 0;
_GL_BLENDFUNC _glBlendFunc = 0;
_GL_CLEAR _glClear = 0;
_GL_CLEARCOLOR _glClearColor = 0;
_GL_CLEARCOLORX _glClearColorx = 0;
_GL_CLEARDEPTHF _glClearDepthf = 0;
_GL_CLEARDEPTHX _glClearDepthx = 0;
_GL_CLEARSTENCIL _glClearStencil = 0;
_GL_CLIENTACTIVETEXTURE _glClientActiveTexture = 0;
_GL_COLOR4F _glColor4f = 0;
_GL_COLOR4X _glColor4x = 0;
_GL_COLORMASK _glColorMask = 0;
_GL_COLORPOINTER _glColorPointer = 0;
_GL_COMPRESSEDTEXIMAGE2D _glCompressedTexImage2D = 0;
_GL_COMPRESSEDTEXSUBIMAGE2D _glCompressedTexSubImage2D = 0;
_GL_COPYTEXIMAGE2D _glCopyTexImage2D = 0;
_GL_COPYTEXSUBIMAGE2D _glCopyTexSubImage2D = 0;
_GL_CULLFACE _glCullFace = 0;
_GL_DELETETEXTURES _glDeleteTextures = 0;
_GL_DEPTHFUNC _glDepthFunc = 0;
_GL_DEPTHMASK _glDepthMask = 0;
_GL_DEPTHRANGEF _glDepthRangef = 0;
_GL_DEPTHRANGEX _glDepthRangex = 0;
_GL_DISABLE _glDisable = 0;
_GL_DISABLECLIENTSTATE _glDisableClientState = 0;
_GL_DRAWARRAYS _glDrawArrays = 0;
_GL_DRAWELEMENTS _glDrawElements = 0;
_GL_ENABLE _glEnable = 0;
_GL_ENABLECLIENTSTATE _glEnableClientState = 0;
_GL_FINISH _glFinish = 0;
_GL_FLUSH _glFlush = 0;
_GL_FOGF _glFogf = 0;
_GL_FOGFV _glFogfv = 0;
_GL_FOGX _glFogx = 0;
_GL_FOGXV _glFogxv = 0;
_GL_FRONTFACE _glFrontFace = 0;
_GL_FRUSTUMF _glFrustumf = 0;
_GL_FRUSTUMX _glFrustumx = 0;
_GL_GENTEXTURES _glGenTextures = 0;
_GL_GETERROR _glGetError = 0;
_GL_GETINTEGERV _glGetIntegerv = 0;
_GL_GETSTRING _glGetString = 0;
_GL_HINT _glHint = 0;
_GL_LIGHTF _glLightf = 0;
_GL_LIGHTFV _glLightfv = 0;
_GL_LIGHTX _glLightx = 0;
_GL_LIGHTXV _glLightxv = 0;
_GL_LIGHTMODELF _glLightModelf = 0;
_GL_LIGHTMODELFV _glLightModelfv = 0;
_GL_LIGHTMODELX _glLightModelx = 0;
_GL_LIGHTMODELXV _glLightModelxv = 0;
_GL_LINEWIDTH _glLineWidth = 0;
_GL_LINEWIDTHX _glLineWidthx = 0;
_GL_LOADIDENTITY _glLoadIdentity = 0;
_GL_LOADMATRIXF _glLoadMatrixf = 0;
_GL_LOADMATRIXX _glLoadMatrixx = 0;
_GL_LOGICOP _glLogicOp = 0;
_GL_MATERIALF _glMaterialf = 0;
_GL_MATERIALFV _glMaterialfv = 0;
_GL_MATERIALX _glMaterialx = 0;
_GL_MATERIALXV _glMaterialxv = 0;
_GL_MATRIXMODE _glMatrixMode = 0;
_GL_MULTITEXCOORD4F _glMultiTexCoord4f = 0;
_GL_MULTITEXCOORD4X _glMultiTexCoord4x = 0;
_GL_MULTMATRIXF _glMultMatrixf = 0;
_GL_MULTMATRIXX _glMultMatrixx = 0;
_GL_NORMAL3F _glNormal3f = 0;
_GL_NORMAL3X _glNormal3x = 0;
_GL_NORMALPOINTER _glNormalPointer = 0;
_GL_ORTHOF _glOrthof = 0;
_GL_ORTHOX _glOrthox = 0;
_GL_PIXELSTOREI _glPixelStorei = 0;
_GL_POINTSIZE _glPointSize = 0;
_GL_POINTSIZEX _glPointSizex = 0;
_GL_POLYGONOFFSET _glPolygonOffset = 0;
_GL_POLYGONOFFSETX _glPolygonOffsetx = 0;
_GL_POPMATRIX _glPopMatrix = 0;
_GL_PUSHMATRIX _glPushMatrix = 0;
_GL_READPIXELS _glReadPixels = 0;
_GL_ROTATEF _glRotatef = 0;
_GL_ROTATEX _glRotatex = 0;
_GL_SAMPLECOVERAGE _glSampleCoverage = 0;
_GL_SAMPLECOVERAGEX _glSampleCoveragex = 0;
_GL_SCALEF _glScalef = 0;
_GL_SCALEX _glScalex = 0;
_GL_SCISSOR _glScissor = 0;
_GL_SHADEMODEL _glShadeModel = 0;
_GL_STENCILFUNC _glStencilFunc = 0;
_GL_STENCILMASK _glStencilMask = 0;
_GL_STENCILOP _glStencilOp = 0;
_GL_TEXCOORDPOINTER _glTexCoordPointer = 0;
_GL_TEXENVF _glTexEnvf = 0;
_GL_TEXENVFV _glTexEnvfv = 0;
_GL_TEXENVX _glTexEnvx = 0;
_GL_TEXENVXV _glTexEnvxv = 0;
_GL_TEXIMAGE2D _glTexImage2D = 0;
_GL_TEXPARAMETERF _glTexParameterf = 0;
_GL_TEXPARAMETERX _glTexParameterx = 0;
_GL_TEXSUBIMAGE2D _glTexSubImage2D = 0;
_GL_TRANSLATEF _glTranslatef = 0;
_GL_TRANSLATEX _glTranslatex = 0;
_GL_VERTEXPOINTER _glVertexPointer = 0;
_GL_VIEWPORT _glViewport = 0;

// OGL-ES 1.0 functions
_GL_BINDBUFFER _glBindBuffer = 0;
_GL_BUFFERDATA _glBufferData = 0;
_GL_BUFFERSUBDATA _glBufferSubData = 0;
_GL_COLOR4UB _glColor4ub = 0;
_GL_CURRENTPALETTEMATRIXOES _glCurrentPaletteMatrixOES = 0;
_GL_DELETEBUFFERS _glDeleteBuffers = 0;
_GL_GENBUFFERS _glGenBuffers = 0;
_GL_GETBOOLEANV _glGetBooleanv = 0;
_GL_GETBUFFERPARAMETERIV _glGetBufferParameteriv = 0;
_GL_GETCLIPPLANEF _glGetClipPlanef = 0;
_GL_GETCLIPPLANEX _glGetClipPlanex = 0;
_GL_GETFLOATV _glGetFloatv = 0;
_GL_GETFIXEDV _glGetFixedv = 0;
_GL_GETLIGHTFV _glGetLightfv = 0;
_GL_GETLIGHTXV _glGetLightxv = 0;
_GL_GETMATERIALFV _glGetMaterialfv = 0;
_GL_GETMATERIALXV _glGetMaterialxv = 0;
_GL_GETPOINTERV _glGetPointerv = 0;
_GL_GETTEXENVFV _glGetTexEnvfv = 0;
_GL_GETTEXENVIV _glGetTexEnviv = 0;
_GL_GETTEXENVXV _glGetTexEnvxv = 0;
_GL_GETTEXPARAMETERIV _glGetTexParameteriv = 0;
_GL_GETTEXPARAMETERFV _glGetTexParameterfv = 0;
_GL_GETTEXPARAMETERXV _glGetTexParameterxv = 0;
_GL_ISENABLED _glIsEnabled = 0;
_GL_ISTEXTURE _glIsTexture = 0;
_GL_ISBUFFER _glIsBuffer = 0;
_GL_LOADPALETTEFROMMODELVIEWMATRIXOES _glLoadPaletteFromModelViewMatrixOES = 0;
_GL_MATRIXINDEXPOINTEROES _glMatrixIndexPointerOES = 0;
_GL_WEIGHTPOINTEROES _glWeightPointerOES = 0;
_GL_CLIPPLANEF _glClipPlanef = 0;
_GL_CLIPPLANEX _glClipPlanex = 0;
_GL_POINTSIZEPOINTEROES _glPointSizePointerOES = 0;
_GL_POINTPARAMETERFV _glPointParameterfv = 0;
_GL_POINTPARAMETERXV _glPointParameterxv = 0;
_GL_POINTPARAMETERF _glPointParameterf = 0;
_GL_POINTPARAMETERX _glPointParameterx = 0;
_GL_DRAWTEXFOES _glDrawTexfOES = 0;
_GL_DRAWTEXXOES _glDrawTexxOES = 0;
_GL_DRAWTEXIOES _glDrawTexiOES = 0;
_GL_DRAWTEXSOES _glDrawTexsOES = 0;
_GL_DRAWTEXFVOES _glDrawTexfvOES = 0;
_GL_DRAWTEXXVOES _glDrawTexxvOES = 0;
_GL_DRAWTEXIVOES _glDrawTexivOES = 0;
_GL_DRAWTEXSVOES _glDrawTexsvOES = 0;
_GL_TEXPARAMETERI _glTexParameteri = 0;
_GL_TEXPARAMETERFV _glTexParameterfv = 0;
_GL_TEXPARAMETERXV _glTexParameterxv = 0;
_GL_TEXPARAMETERIV _glTexParameteriv = 0;


_EGL_GetError _eglGetError = 0;
_EGL_GETDISPLAY _eglGetDisplay = 0;
_EGL_INITIALIZE _eglInitialize = 0;
_EGL_TERMINATE _eglTerminate = 0;
_EGL_QUERYSTRING _eglQueryString = 0;
_EGL_GETCONFIGS _eglGetConfigs = 0;
_EGL_CHOOSECONFIG _eglChooseConfig = 0;
_EGL_GETCONFIGATTRIB _eglGetConfigAttrib = 0;
_EGL_CREATEWINDOWSURFACE _eglCreateWindowSurface = 0;
_EGL_CREATEPBUFFERSURFACE _eglCreatePbufferSurface = 0;
_EGL_CREATEPIXMAPSURFACE _eglCreatePixmapSurface = 0;
_EGL_DESTROYSURFACE _eglDestroySurface = 0;
_EGL_QUERYSURFACE _eglQuerySurface = 0;
_EGL_SURFACEATTRIB _eglSurfaceAttrib = 0;
_EGL_BINDTEXIMAGE _eglBindTexImage = 0;
_EGL_RELEASETEXIMAGE _eglReleaseTexImage = 0;
_EGL_SWAPINTERVAL _eglSwapInterval = 0;
_EGL_CREATECONTEXT _eglCreateContext = 0;
_EGL_DESTROYCONTEXT _eglDestroyContext = 0;
_EGL_MAKECURRENT _eglMakeCurrent = 0;
_EGL_GETCURRENTCONTEXT _eglGetCurrentContext = 0;
_EGL_GETCURRENTSURFACE _eglGetCurrentSurface = 0;
_EGL_GETCURRENTDISPLAY _eglGetCurrentDisplay = 0;
_EGL_QUERYCONTEXT _eglQueryContext = 0;
_EGL_WAITGL _eglWaitGL = 0;
_EGL_WAITNATIVE _eglWaitNative = 0;
_EGL_SWAPBUFFERS _eglSwapBuffers = 0;
_EGL_COPYBUFFERS _eglCopyBuffers = 0;

#ifdef _IS_WIN32_
  #define _T(x)  x
  #define STRCPY strcpy
  #define STRLEN strlen
  #define STRCAT strcat
#else
  #define STRCPY wcscpy
  #define STRLEN wcslen
  #define STRCAT wcscat
#endif //_IS_WIN32_


const TCHAR* makeStringNative(const char* nStr)
{
#ifdef _IS_WIN32_
	return nStr;
#else
	static TCHAR wstr[256];
	for(unsigned i=0; i<strlen(nStr)+1; i++)
		wstr[i] = nStr[i];
	return wstr;
#endif //_IS_WIN32_
}


bool
bindGLESFunctions(bool nShowReport)
{
	HMODULE hLib = NULL;

	// first load the library...
	//
	hLib = ::LoadLibrary(makeStringNative("libGLES_CM.dll"));
	if(!hLib)
		hLib = ::LoadLibrary(makeStringNative("libGLES_CL.dll"));


	if(!hLib)
	{
		::MessageBox(NULL, _T("Failed to load OpenGL|ES DLL"), _T("ERROR"), MB_OK);
		return false;
	}

#ifndef _SUPPORT_LITE_
	_glAlphaFunc = (_GL_ALPHAFUNC)GetProcAddress(hLib, _T("glAlphaFunc"));
	_glClearColor = (_GL_CLEARCOLOR)GetProcAddress(hLib, _T("glClearColor"));
	_glClearDepthf = (_GL_CLEARDEPTHF)GetProcAddress(hLib, _T("glClearDepthf"));
	_glColor4f = (_GL_COLOR4F)GetProcAddress(hLib, _T("glColor4f"));
	_glDepthRangef = (_GL_DEPTHRANGEF)GetProcAddress(hLib, _T("glDepthRangef"));
	_glFogf = (_GL_FOGF)GetProcAddress(hLib, _T("glFogf"));
	_glFogfv = (_GL_FOGFV)GetProcAddress(hLib, _T("glFogfv"));
	_glFrustumf = (_GL_FRUSTUMF)GetProcAddress(hLib, _T("glFrustumf"));
	_glLightf = (_GL_LIGHTF)GetProcAddress(hLib, _T("glLightf"));
	_glLightfv = (_GL_LIGHTFV)GetProcAddress(hLib, _T("glLightfv"));
	_glLightModelf = (_GL_LIGHTMODELF)GetProcAddress(hLib, _T("glLightModelf"));
	_glLightModelfv = (_GL_LIGHTMODELFV)GetProcAddress(hLib, _T("glLightModelfv"));
	_glLineWidth = (_GL_LINEWIDTH)GetProcAddress(hLib, _T("glLineWidth"));
	_glLoadMatrixf = (_GL_LOADMATRIXF)GetProcAddress(hLib, _T("glLoadMatrixf"));
	_glMaterialf = (_GL_MATERIALF)GetProcAddress(hLib, _T("glMaterialf"));
	_glMaterialfv = (_GL_MATERIALFV)GetProcAddress(hLib, _T("glMaterialfv"));
	_glMultiTexCoord4f = (_GL_MULTITEXCOORD4F)GetProcAddress(hLib, _T("glMultiTexCoord4f"));
	_glMultMatrixf = (_GL_MULTMATRIXF)GetProcAddress(hLib, _T("glMultMatrixf"));
	_glNormal3f = (_GL_NORMAL3F)GetProcAddress(hLib, _T("glNormal3f"));
	_glOrthof = (_GL_ORTHOF)GetProcAddress(hLib, _T("glOrthof"));
	_glPointSize = (_GL_POINTSIZE)GetProcAddress(hLib, _T("glPointSize"));
	_glPolygonOffset = (_GL_POLYGONOFFSET)GetProcAddress(hLib, _T("glPolygonOffset"));
	_glRotatef = (_GL_ROTATEF)GetProcAddress(hLib, _T("glRotatef"));
	_glSampleCoverage = (_GL_SAMPLECOVERAGE)GetProcAddress(hLib, _T("glSampleCoverage"));
	_glScalef = (_GL_SCALEF)GetProcAddress(hLib, _T("glScalef"));
	_glTexEnvf = (_GL_TEXENVF)GetProcAddress(hLib, _T("glTexEnvf"));
	_glTexEnvfv = (_GL_TEXENVFV)GetProcAddress(hLib, _T("glTexEnvfv"));
	_glTexParameterf = (_GL_TEXPARAMETERF)GetProcAddress(hLib, _T("glTexParameterf"));
	_glTranslatef = (_GL_TRANSLATEF)GetProcAddress(hLib, _T("glTranslatef"));
	_glBindBuffer = (_GL_BINDBUFFER)GetProcAddress(hLib, _T("glBindBuffer"));
	_glBufferData = (_GL_BUFFERDATA)GetProcAddress(hLib, _T("glBufferData"));
	_glBufferSubData = (_GL_BUFFERSUBDATA)GetProcAddress(hLib, _T("glBufferSubData"));
	_glColor4ub = (_GL_COLOR4UB)GetProcAddress(hLib, _T("glColor4ub"));
	_glCurrentPaletteMatrixOES = (_GL_CURRENTPALETTEMATRIXOES)GetProcAddress(hLib, _T("glCurrentPaletteMatrixOES"));
	_glDeleteBuffers = (_GL_DELETEBUFFERS)GetProcAddress(hLib, _T("glDeleteBuffers"));
	_glGenBuffers = (_GL_GENBUFFERS)GetProcAddress(hLib, _T("glGenBuffers"));
	_glGetBooleanv = (_GL_GETBOOLEANV)GetProcAddress(hLib, _T("glGetBooleanv"));
	_glGetBufferParameteriv = (_GL_GETBUFFERPARAMETERIV)GetProcAddress(hLib, _T("glGetBufferParameteriv"));
	_glGetClipPlanef = (_GL_GETCLIPPLANEF)GetProcAddress(hLib, _T("glGetClipPlanef"));
	_glGetClipPlanex = (_GL_GETCLIPPLANEX)GetProcAddress(hLib, _T("glGetClipPlanex"));
	_glGetFloatv = (_GL_GETFLOATV)GetProcAddress(hLib, _T("glGetFloatv"));
	_glGetFixedv = (_GL_GETFIXEDV)GetProcAddress(hLib, _T("glGetFixedv"));
	_glGetLightfv = (_GL_GETLIGHTFV)GetProcAddress(hLib, _T("glGetLightfv"));
	_glGetLightxv = (_GL_GETLIGHTXV)GetProcAddress(hLib, _T("glGetLightxv"));
	_glGetMaterialfv = (_GL_GETMATERIALFV)GetProcAddress(hLib, _T("glGetMaterialfv"));
	_glGetMaterialxv = (_GL_GETMATERIALXV)GetProcAddress(hLib, _T("glGetMaterialxv"));
	_glGetPointerv = (_GL_GETPOINTERV)GetProcAddress(hLib, _T("glGetPointerv"));
	_glGetTexEnvfv = (_GL_GETTEXENVFV)GetProcAddress(hLib, _T("glGetTexEnvfv"));
	_glGetTexEnviv = (_GL_GETTEXENVIV)GetProcAddress(hLib, _T("glGetTexEnviv"));
	_glGetTexEnvxv = (_GL_GETTEXENVXV)GetProcAddress(hLib, _T("glGetTexEnvxv"));
	_glGetTexParameteriv = (_GL_GETTEXPARAMETERIV)GetProcAddress(hLib, _T("glGetTexParameteriv"));
	_glGetTexParameterfv = (_GL_GETTEXPARAMETERFV)GetProcAddress(hLib, _T("glGetTexParameterfv"));
	_glGetTexParameterxv = (_GL_GETTEXPARAMETERXV)GetProcAddress(hLib, _T("glGetTexParameterxv"));
	_glIsEnabled = (_GL_ISENABLED)GetProcAddress(hLib, _T("glIsEnabled"));
	_glIsTexture = (_GL_ISTEXTURE)GetProcAddress(hLib, _T("glIsTexture"));
	_glIsBuffer = (_GL_ISBUFFER)GetProcAddress(hLib, _T("glIsBuffer"));
	_glLoadPaletteFromModelViewMatrixOES = (_GL_LOADPALETTEFROMMODELVIEWMATRIXOES)GetProcAddress(hLib, _T("glLoadPaletteFromModelViewMatrixOES"));
	_glMatrixIndexPointerOES = (_GL_MATRIXINDEXPOINTEROES)GetProcAddress(hLib, _T("glMatrixIndexPointerOES"));
	_glWeightPointerOES = (_GL_WEIGHTPOINTEROES)GetProcAddress(hLib, _T("glWeightPointerOES"));
	_glClipPlanef = (_GL_CLIPPLANEF)GetProcAddress(hLib, _T("glClipPlanef"));
	_glClipPlanex = (_GL_CLIPPLANEX)GetProcAddress(hLib, _T("glClipPlanex"));
	_glPointSizePointerOES = (_GL_POINTSIZEPOINTEROES)GetProcAddress(hLib, _T("glPointSizePointerOES"));
	_glPointParameterfv = (_GL_POINTPARAMETERFV)GetProcAddress(hLib, _T("glPointParameterfv"));
	_glPointParameterxv = (_GL_POINTPARAMETERXV)GetProcAddress(hLib, _T("glPointParameterxv"));
	_glPointParameterf = (_GL_POINTPARAMETERF)GetProcAddress(hLib, _T("glPointParameterf"));
	_glPointParameterx = (_GL_POINTPARAMETERX)GetProcAddress(hLib, _T("glPointParameterx"));
	_glDrawTexfOES = (_GL_DRAWTEXFOES)GetProcAddress(hLib, _T("glDrawTexfOES"));
	_glDrawTexxOES = (_GL_DRAWTEXXOES)GetProcAddress(hLib, _T("glDrawTexxOES"));
	_glDrawTexiOES = (_GL_DRAWTEXIOES)GetProcAddress(hLib, _T("glDrawTexiOES"));
	_glDrawTexsOES = (_GL_DRAWTEXSOES)GetProcAddress(hLib, _T("glDrawTexsOES"));
	_glDrawTexfvOES = (_GL_DRAWTEXFVOES)GetProcAddress(hLib, _T("glDrawTexfvOES"));
	_glDrawTexxvOES = (_GL_DRAWTEXXVOES)GetProcAddress(hLib, _T("glDrawTexxvOES"));
	_glDrawTexivOES = (_GL_DRAWTEXIVOES)GetProcAddress(hLib, _T("glDrawTexivOES"));
	_glDrawTexsvOES = (_GL_DRAWTEXSVOES)GetProcAddress(hLib, _T("glDrawTexsvOES"));
	_glTexParameteri = (_GL_TEXPARAMETERI)GetProcAddress(hLib, _T("glTexParameteri"));
	_glTexParameterfv = (_GL_TEXPARAMETERFV)GetProcAddress(hLib, _T("glTexParameterfv"));
	_glTexParameterxv = (_GL_TEXPARAMETERXV)GetProcAddress(hLib, _T("glTexParameterxv"));
	_glTexParameteriv = (_GL_TEXPARAMETERIV)GetProcAddress(hLib, _T("glTexParameteriv"));
	_eglSurfaceAttrib = (_EGL_SURFACEATTRIB)GetProcAddress(hLib, _T("eglSurfaceAttrib"));
	_eglBindTexImage = (_EGL_BINDTEXIMAGE)GetProcAddress(hLib, _T("eglBindTexImage"));
	_eglReleaseTexImage = (_EGL_RELEASETEXIMAGE)GetProcAddress(hLib, _T("eglReleaseTexImage"));
	_eglSwapInterval = (_EGL_SWAPINTERVAL)GetProcAddress(hLib, _T("eglSwapInterval"));
#endif //_SUPPORT_LITE_

	_glActiveTexture = (_GL_ACTIVETEXTURE)GetProcAddress(hLib, _T("glActiveTexture"));
	_glAlphaFuncx = (_GL_ALPHAFUNCX)GetProcAddress(hLib, _T("glAlphaFuncx"));
	_glBindTexture = (_GL_BINDTEXTURE)GetProcAddress(hLib, _T("glBindTexture"));
	_glBlendFunc = (_GL_BLENDFUNC)GetProcAddress(hLib, _T("glBlendFunc"));
	_glClear = (_GL_CLEAR)GetProcAddress(hLib, _T("glClear"));
	_glClearColorx = (_GL_CLEARCOLORX)GetProcAddress(hLib, _T("glClearColorx"));
	_glClearDepthx = (_GL_CLEARDEPTHX)GetProcAddress(hLib, _T("glClearDepthx"));
	_glClearStencil = (_GL_CLEARSTENCIL)GetProcAddress(hLib, _T("glClearStencil"));
	_glClientActiveTexture = (_GL_CLIENTACTIVETEXTURE)GetProcAddress(hLib, _T("glClientActiveTexture"));
	_glColor4x = (_GL_COLOR4X)GetProcAddress(hLib, _T("glColor4x"));
	_glColorMask = (_GL_COLORMASK)GetProcAddress(hLib, _T("glColorMask"));
	_glColorPointer = (_GL_COLORPOINTER)GetProcAddress(hLib, _T("glColorPointer"));
	_glCompressedTexImage2D = (_GL_COMPRESSEDTEXIMAGE2D)GetProcAddress(hLib, _T("glCompressedTexImage2D"));
	_glCompressedTexSubImage2D = (_GL_COMPRESSEDTEXSUBIMAGE2D)GetProcAddress(hLib, _T("glCompressedTexSubImage2D"));
	_glCopyTexImage2D = (_GL_COPYTEXIMAGE2D)GetProcAddress(hLib, _T("glCopyTexImage2D"));
	_glCopyTexSubImage2D = (_GL_COPYTEXSUBIMAGE2D)GetProcAddress(hLib, _T("glCopyTexSubImage2D"));
	_glCullFace = (_GL_CULLFACE)GetProcAddress(hLib, _T("glCullFace"));
	_glDeleteTextures = (_GL_DELETETEXTURES)GetProcAddress(hLib, _T("glDeleteTextures"));
	_glDepthFunc = (_GL_DEPTHFUNC)GetProcAddress(hLib, _T("glDepthFunc"));
	_glDepthMask = (_GL_DEPTHMASK)GetProcAddress(hLib, _T("glDepthMask"));
	_glDepthRangex = (_GL_DEPTHRANGEX)GetProcAddress(hLib, _T("glDepthRangex"));
	_glDisable = (_GL_DISABLE)GetProcAddress(hLib, _T("glDisable"));
	_glDisableClientState = (_GL_DISABLECLIENTSTATE)GetProcAddress(hLib, _T("glDisableClientState"));
	_glDrawArrays = (_GL_DRAWARRAYS)GetProcAddress(hLib, _T("glDrawArrays"));
	_glDrawElements = (_GL_DRAWELEMENTS)GetProcAddress(hLib, _T("glDrawElements"));
	_glEnable = (_GL_ENABLE)GetProcAddress(hLib, _T("glEnable"));
	_glEnableClientState = (_GL_ENABLECLIENTSTATE)GetProcAddress(hLib, _T("glEnableClientState"));
	_glFinish = (_GL_FINISH)GetProcAddress(hLib, _T("glFinish"));
	_glFlush = (_GL_FLUSH)GetProcAddress(hLib, _T("glFlush"));
	_glFogx = (_GL_FOGX)GetProcAddress(hLib, _T("glFogx"));
	_glFogxv = (_GL_FOGXV)GetProcAddress(hLib, _T("glFogxv"));
	_glFrontFace = (_GL_FRONTFACE)GetProcAddress(hLib, _T("glFrontFace"));
	_glFrustumx = (_GL_FRUSTUMX)GetProcAddress(hLib, _T("glFrustumx"));
	_glGenTextures = (_GL_GENTEXTURES)GetProcAddress(hLib, _T("glGenTextures"));
	_glGetError = (_GL_GETERROR)GetProcAddress(hLib, _T("glGetError"));
	_glGetIntegerv = (_GL_GETINTEGERV)GetProcAddress(hLib, _T("glGetIntegerv"));
	_glGetString = (_GL_GETSTRING)GetProcAddress(hLib, _T("glGetString"));
	_glHint = (_GL_HINT)GetProcAddress(hLib, _T("glHint"));
	_glLightx = (_GL_LIGHTX)GetProcAddress(hLib, _T("glLightx"));
	_glLightxv = (_GL_LIGHTXV)GetProcAddress(hLib, _T("glLightxv"));
	_glLightModelx = (_GL_LIGHTMODELX)GetProcAddress(hLib, _T("glLightModelx"));
	_glLightModelxv = (_GL_LIGHTMODELXV)GetProcAddress(hLib, _T("glLightModelxv"));
	_glLineWidthx = (_GL_LINEWIDTHX)GetProcAddress(hLib, _T("glLineWidthx"));
	_glLoadIdentity = (_GL_LOADIDENTITY)GetProcAddress(hLib, _T("glLoadIdentity"));
	_glLoadMatrixx = (_GL_LOADMATRIXX)GetProcAddress(hLib, _T("glLoadMatrixx"));
	_glLogicOp = (_GL_LOGICOP)GetProcAddress(hLib, _T("glLogicOp"));
	_glMaterialx = (_GL_MATERIALX)GetProcAddress(hLib, _T("glMaterialx"));
	_glMaterialxv = (_GL_MATERIALXV)GetProcAddress(hLib, _T("glMaterialxv"));
	_glMatrixMode = (_GL_MATRIXMODE)GetProcAddress(hLib, _T("glMatrixMode"));
	_glMultiTexCoord4x = (_GL_MULTITEXCOORD4X)GetProcAddress(hLib, _T("glMultiTexCoord4x"));
	_glMultMatrixx = (_GL_MULTMATRIXX)GetProcAddress(hLib, _T("glMultMatrixx"));
	_glNormal3x = (_GL_NORMAL3X)GetProcAddress(hLib, _T("glNormal3x"));
	_glNormalPointer = (_GL_NORMALPOINTER)GetProcAddress(hLib, _T("glNormalPointer"));
	_glOrthox = (_GL_ORTHOX)GetProcAddress(hLib, _T("glOrthox"));
	_glPixelStorei = (_GL_PIXELSTOREI)GetProcAddress(hLib, _T("glPixelStorei"));
	_glPointSizex = (_GL_POINTSIZEX)GetProcAddress(hLib, _T("glPointSizex"));
	_glPolygonOffsetx = (_GL_POLYGONOFFSETX)GetProcAddress(hLib, _T("glPolygonOffsetx"));
	_glPopMatrix = (_GL_POPMATRIX)GetProcAddress(hLib, _T("glPopMatrix"));
	_glPushMatrix = (_GL_PUSHMATRIX)GetProcAddress(hLib, _T("glPushMatrix"));
	_glReadPixels = (_GL_READPIXELS)GetProcAddress(hLib, _T("glReadPixels"));
	_glRotatex = (_GL_ROTATEX)GetProcAddress(hLib, _T("glRotatex"));
	_glSampleCoveragex = (_GL_SAMPLECOVERAGEX)GetProcAddress(hLib, _T("glSampleCoveragex"));
	_glScalex = (_GL_SCALEX)GetProcAddress(hLib, _T("glScalex"));
	_glScissor = (_GL_SCISSOR)GetProcAddress(hLib, _T("glScissor"));
	_glShadeModel = (_GL_SHADEMODEL)GetProcAddress(hLib, _T("glShadeModel"));
	_glStencilFunc = (_GL_STENCILFUNC)GetProcAddress(hLib, _T("glStencilFunc"));
	_glStencilMask = (_GL_STENCILMASK)GetProcAddress(hLib, _T("glStencilMask"));
	_glStencilOp = (_GL_STENCILOP)GetProcAddress(hLib, _T("glStencilOp"));
	_glTexCoordPointer = (_GL_TEXCOORDPOINTER)GetProcAddress(hLib, _T("glTexCoordPointer"));
	_glTexEnvx = (_GL_TEXENVX)GetProcAddress(hLib, _T("glTexEnvx"));
	_glTexEnvxv = (_GL_TEXENVXV)GetProcAddress(hLib, _T("glTexEnvxv"));
	_glTexImage2D = (_GL_TEXIMAGE2D)GetProcAddress(hLib, _T("glTexImage2D"));
	_glTexParameterx = (_GL_TEXPARAMETERX)GetProcAddress(hLib, _T("glTexParameterx"));
	_glTexSubImage2D = (_GL_TEXSUBIMAGE2D)GetProcAddress(hLib, _T("glTexSubImage2D"));
	_glTranslatex = (_GL_TRANSLATEX)GetProcAddress(hLib, _T("glTranslatex"));
	_glVertexPointer = (_GL_VERTEXPOINTER)GetProcAddress(hLib, _T("glVertexPointer"));
	_glViewport = (_GL_VIEWPORT)GetProcAddress(hLib, _T("glViewport"));
	_eglGetError = (_EGL_GetError)GetProcAddress(hLib, _T("eglGetError"));
	_eglGetDisplay = (_EGL_GETDISPLAY)GetProcAddress(hLib, _T("eglGetDisplay"));
	_eglInitialize = (_EGL_INITIALIZE)GetProcAddress(hLib, _T("eglInitialize"));
	_eglTerminate = (_EGL_TERMINATE)GetProcAddress(hLib, _T("eglTerminate"));
	_eglQueryString = (_EGL_QUERYSTRING)GetProcAddress(hLib, _T("eglQueryString"));
	_eglGetConfigs = (_EGL_GETCONFIGS)GetProcAddress(hLib, _T("eglGetConfigs"));
	_eglChooseConfig = (_EGL_CHOOSECONFIG)GetProcAddress(hLib, _T("eglChooseConfig"));
	_eglGetConfigAttrib = (_EGL_GETCONFIGATTRIB)GetProcAddress(hLib, _T("eglGetConfigAttrib"));
	_eglCreateWindowSurface = (_EGL_CREATEWINDOWSURFACE)GetProcAddress(hLib, _T("eglCreateWindowSurface"));
	_eglCreatePbufferSurface = (_EGL_CREATEPBUFFERSURFACE)GetProcAddress(hLib, _T("eglCreatePbufferSurface"));
	_eglCreatePixmapSurface = (_EGL_CREATEPIXMAPSURFACE)GetProcAddress(hLib, _T("eglCreatePixmapSurface"));
	_eglDestroySurface = (_EGL_DESTROYSURFACE)GetProcAddress(hLib, _T("eglDestroySurface"));
	_eglQuerySurface = (_EGL_QUERYSURFACE)GetProcAddress(hLib, _T("eglQuerySurface"));
	_eglCreateContext = (_EGL_CREATECONTEXT)GetProcAddress(hLib, _T("eglCreateContext"));
	_eglDestroyContext = (_EGL_DESTROYCONTEXT)GetProcAddress(hLib, _T("eglDestroyContext"));
	_eglMakeCurrent = (_EGL_MAKECURRENT)GetProcAddress(hLib, _T("eglMakeCurrent"));
	_eglGetCurrentContext = (_EGL_GETCURRENTCONTEXT)GetProcAddress(hLib, _T("eglGetCurrentContext"));
	_eglGetCurrentSurface = (_EGL_GETCURRENTSURFACE)GetProcAddress(hLib, _T("eglGetCurrentSurface"));
	_eglGetCurrentDisplay = (_EGL_GETCURRENTDISPLAY)GetProcAddress(hLib, _T("eglGetCurrentDisplay"));
	_eglQueryContext = (_EGL_QUERYCONTEXT)GetProcAddress(hLib, _T("eglQueryContext"));
	_eglWaitGL = (_EGL_WAITGL)GetProcAddress(hLib, _T("eglWaitGL"));
	_eglWaitNative = (_EGL_WAITNATIVE)GetProcAddress(hLib, _T("eglWaitNative"));
	_eglSwapBuffers = (_EGL_SWAPBUFFERS)GetProcAddress(hLib, _T("eglSwapBuffers"));
	_eglCopyBuffers = (_EGL_COPYBUFFERS)GetProcAddress(hLib, _T("eglCopyBuffers"));


	if(nShowReport)
	{
		TCHAR* msg = new TCHAR[4096];
		STRCPY(msg, _T("Failed to import: "));
		unsigned int len0 = STRLEN(msg);
		

		if(!_glActiveTexture) STRCAT(msg, _T(", glActiveTexture"));
		if(!_glAlphaFunc) STRCAT(msg, _T(", glAlphaFunc"));
		if(!_glAlphaFuncx) STRCAT(msg, _T(", glAlphaFuncx"));
		if(!_glBindTexture) STRCAT(msg, _T(", glBindTexture"));
		if(!_glBlendFunc) STRCAT(msg, _T(", glBlendFunc"));
		if(!_glClear) STRCAT(msg, _T(", glClear"));
		if(!_glClearColor) STRCAT(msg, _T(", glClearColor"));
		if(!_glClearColorx) STRCAT(msg, _T(", glClearColorx"));
		if(!_glClearDepthf) STRCAT(msg, _T(", glClearDepthf"));
		if(!_glClearDepthx) STRCAT(msg, _T(", glClearDepthx"));
		if(!_glClearStencil) STRCAT(msg, _T(", glClearStencil"));
		if(!_glClientActiveTexture) STRCAT(msg, _T(", glClientActiveTexture"));
		if(!_glColor4f) STRCAT(msg, _T(", glColor4f"));
		if(!_glColor4x) STRCAT(msg, _T(", glColor4x"));
		if(!_glColorMask) STRCAT(msg, _T(", glColorMask"));
		if(!_glColorPointer) STRCAT(msg, _T(", glColorPointer"));
		if(!_glCompressedTexImage2D) STRCAT(msg, _T(", glCompressedTexImage2D"));
		if(!_glCompressedTexSubImage2D) STRCAT(msg, _T(", glCompressedTexSubImage2D"));
		if(!_glCopyTexImage2D) STRCAT(msg, _T(", glCopyTexImage2D"));
		if(!_glCopyTexSubImage2D) STRCAT(msg, _T(", glCopyTexSubImage2D"));
		if(!_glCullFace) STRCAT(msg, _T(", glCullFace"));
		if(!_glDeleteTextures) STRCAT(msg, _T(", glDeleteTextures"));
		if(!_glDepthFunc) STRCAT(msg, _T(", glDepthFunc"));
		if(!_glDepthMask) STRCAT(msg, _T(", glDepthMask"));
		if(!_glDepthRangef) STRCAT(msg, _T(", glDepthRangef"));
		if(!_glDepthRangex) STRCAT(msg, _T(", glDepthRangex"));
		if(!_glDisable) STRCAT(msg, _T(", glDisable"));
		if(!_glDisableClientState) STRCAT(msg, _T(", glDisableClientState"));
		if(!_glDrawArrays) STRCAT(msg, _T(", glDrawArrays"));
		if(!_glDrawElements) STRCAT(msg, _T(", glDrawElements"));
		if(!_glEnable) STRCAT(msg, _T(", glEnable"));
		if(!_glEnableClientState) STRCAT(msg, _T(", glEnableClientState"));
		if(!_glFinish) STRCAT(msg, _T(", glFinish"));
		if(!_glFlush) STRCAT(msg, _T(", glFlush"));
		if(!_glFogf) STRCAT(msg, _T(", glFogf"));
		if(!_glFogfv) STRCAT(msg, _T(", glFogfv"));
		if(!_glFogx) STRCAT(msg, _T(", glFogx"));
		if(!_glFogxv) STRCAT(msg, _T(", glFogxv"));
		if(!_glFrontFace) STRCAT(msg, _T(", glFrontFace"));
		if(!_glFrustumf) STRCAT(msg, _T(", glFrustumf"));
		if(!_glFrustumx) STRCAT(msg, _T(", glFrustumx"));
		if(!_glGenTextures) STRCAT(msg, _T(", glGenTextures"));
		if(!_glGetError) STRCAT(msg, _T(", glGetError"));
		if(!_glGetIntegerv) STRCAT(msg, _T(", glGetIntegerv"));
		if(!_glGetString) STRCAT(msg, _T(", glGetString"));
		if(!_glHint) STRCAT(msg, _T(", glHint"));
		if(!_glLightf) STRCAT(msg, _T(", glLightf"));
		if(!_glLightfv) STRCAT(msg, _T(", glLightfv"));
		if(!_glLightx) STRCAT(msg, _T(", glLightx"));
		if(!_glLightxv) STRCAT(msg, _T(", glLightxv"));
		if(!_glLightModelf) STRCAT(msg, _T(", glLightModelf"));
		if(!_glLightModelfv) STRCAT(msg, _T(", glLightModelfv"));
		if(!_glLightModelx) STRCAT(msg, _T(", glLightModelx"));
		if(!_glLightModelxv) STRCAT(msg, _T(", glLightModelxv"));
		if(!_glLineWidth) STRCAT(msg, _T(", glLineWidth"));
		if(!_glLineWidthx) STRCAT(msg, _T(", glLineWidthx"));
		if(!_glLoadIdentity) STRCAT(msg, _T(", glLoadIdentity"));
		if(!_glLoadMatrixf) STRCAT(msg, _T(", glLoadMatrixf"));
		if(!_glLoadMatrixx) STRCAT(msg, _T(", glLoadMatrixx"));
		if(!_glLogicOp) STRCAT(msg, _T(", glLogicOp"));
		if(!_glMaterialf) STRCAT(msg, _T(", glMaterialf"));
		if(!_glMaterialfv) STRCAT(msg, _T(", glMaterialfv"));
		if(!_glMaterialx) STRCAT(msg, _T(", glMaterialx"));
		if(!_glMaterialxv) STRCAT(msg, _T(", glMaterialxv"));
		if(!_glMatrixMode) STRCAT(msg, _T(", glMatrixMode"));
		if(!_glMultiTexCoord4f) STRCAT(msg, _T(", glMultiTexCoord4f"));
		if(!_glMultiTexCoord4x) STRCAT(msg, _T(", glMultiTexCoord4x"));
		if(!_glMultMatrixf) STRCAT(msg, _T(", glMultMatrixf"));
		if(!_glMultMatrixx) STRCAT(msg, _T(", glMultMatrixx"));
		if(!_glNormal3f) STRCAT(msg, _T(", glNormal3f"));
		if(!_glNormal3x) STRCAT(msg, _T(", glNormal3x"));
		if(!_glNormalPointer) STRCAT(msg, _T(", glNormalPointer"));
		if(!_glOrthof) STRCAT(msg, _T(", glOrthof"));
		if(!_glOrthox) STRCAT(msg, _T(", glOrthox"));
		if(!_glPixelStorei) STRCAT(msg, _T(", glPixelStorei"));
		if(!_glPointSize) STRCAT(msg, _T(", glPointSize"));
		if(!_glPointSizex) STRCAT(msg, _T(", glPointSizex"));
		if(!_glPolygonOffset) STRCAT(msg, _T(", glPolygonOffset"));
		if(!_glPolygonOffsetx) STRCAT(msg, _T(", glPolygonOffsetx"));
		if(!_glPopMatrix) STRCAT(msg, _T(", glPopMatrix"));
		if(!_glPushMatrix) STRCAT(msg, _T(", glPushMatrix"));
		if(!_glReadPixels) STRCAT(msg, _T(", glReadPixels"));
		if(!_glRotatef) STRCAT(msg, _T(", glRotatef"));
		if(!_glRotatex) STRCAT(msg, _T(", glRotatex"));
		if(!_glSampleCoverage) STRCAT(msg, _T(", glSampleCoverage"));
		if(!_glSampleCoveragex) STRCAT(msg, _T(", glSampleCoveragex"));
		if(!_glScalef) STRCAT(msg, _T(", glScalef"));
		if(!_glScalex) STRCAT(msg, _T(", glScalex"));
		if(!_glScissor) STRCAT(msg, _T(", glScissor"));
		if(!_glShadeModel) STRCAT(msg, _T(", glShadeModel"));
		if(!_glStencilFunc) STRCAT(msg, _T(", glStencilFunc"));
		if(!_glStencilMask) STRCAT(msg, _T(", glStencilMask"));
		if(!_glStencilOp) STRCAT(msg, _T(", glStencilOp"));
		if(!_glTexCoordPointer) STRCAT(msg, _T(", glTexCoordPointer"));
		if(!_glTexEnvf) STRCAT(msg, _T(", glTexEnvf"));
		if(!_glTexEnvfv) STRCAT(msg, _T(", glTexEnvfv"));
		if(!_glTexEnvx) STRCAT(msg, _T(", glTexEnvx"));
		if(!_glTexEnvxv) STRCAT(msg, _T(", glTexEnvxv"));
		if(!_glTexImage2D) STRCAT(msg, _T(", glTexImage2D"));
		if(!_glTexParameterf) STRCAT(msg, _T(", glTexParameterf"));
		if(!_glTexParameterx) STRCAT(msg, _T(", glTexParameterx"));
		if(!_glTexSubImage2D) STRCAT(msg, _T(", glTexSubImage2D"));
		if(!_glTranslatef) STRCAT(msg, _T(", glTranslatef"));
		if(!_glTranslatex) STRCAT(msg, _T(", glTranslatex"));
		if(!_glVertexPointer) STRCAT(msg, _T(", glVertexPointer"));
		if(!_glViewport) STRCAT(msg, _T(", glViewport"));
		if(!_glBindBuffer) STRCAT(msg, _T(", glBindBuffer"));
		if(!_glBufferData) STRCAT(msg, _T(", glBufferData"));
		if(!_glBufferSubData) STRCAT(msg, _T(", glBufferSubData"));
//		if(!_glColor4ub) STRCAT(msg, _T(", glColor4ub"));
		if(!_glCurrentPaletteMatrixOES) STRCAT(msg, _T(", glCurrentPaletteMatrixOES"));
		if(!_glDeleteBuffers) STRCAT(msg, _T(", glDeleteBuffers"));
		if(!_glGenBuffers) STRCAT(msg, _T(", glGenBuffers"));
		if(!_glGetBooleanv) STRCAT(msg, _T(", glGetBooleanv"));
		if(!_glGetBufferParameteriv) STRCAT(msg, _T(", glGetBufferParameteriv"));
		if(!_glGetClipPlanef) STRCAT(msg, _T(", glGetClipPlanef"));
		if(!_glGetClipPlanex) STRCAT(msg, _T(", glGetClipPlanex"));
		if(!_glGetFloatv) STRCAT(msg, _T(", glGetFloatv"));
		if(!_glGetFixedv) STRCAT(msg, _T(", glGetFixedv"));
		if(!_glGetLightfv) STRCAT(msg, _T(", glGetLightfv"));
		if(!_glGetLightxv) STRCAT(msg, _T(", glGetLightxv"));
		if(!_glGetMaterialfv) STRCAT(msg, _T(", glGetMaterialfv"));
		if(!_glGetMaterialxv) STRCAT(msg, _T(", glGetMaterialxv"));
		if(!_glGetPointerv) STRCAT(msg, _T(", glGetPointerv"));
		if(!_glGetTexEnvfv) STRCAT(msg, _T(", glGetTexEnvfv"));
		if(!_glGetTexEnviv) STRCAT(msg, _T(", glGetTexEnviv"));
		if(!_glGetTexEnvxv) STRCAT(msg, _T(", glGetTexEnvxv"));
		if(!_glGetTexParameteriv) STRCAT(msg, _T(", glGetTexParameteriv"));
		if(!_glGetTexParameterfv) STRCAT(msg, _T(", glGetTexParameterfv"));
		if(!_glGetTexParameterxv) STRCAT(msg, _T(", glGetTexParameterxv"));
		if(!_glIsEnabled) STRCAT(msg, _T(", glIsEnabled"));
		if(!_glIsTexture) STRCAT(msg, _T(", glIsTexture"));
		if(!_glIsBuffer) STRCAT(msg, _T(", glIsBuffer"));
		if(!_glLoadPaletteFromModelViewMatrixOES) STRCAT(msg, _T(", glLoadPaletteFromModelViewMatrixOES"));
		if(!_glMatrixIndexPointerOES) STRCAT(msg, _T(", glMatrixIndexPointerOES"));
		if(!_glWeightPointerOES) STRCAT(msg, _T(", glWeightPointerOES"));
		if(!_glClipPlanef) STRCAT(msg, _T(", glClipPlanef"));
		if(!_glClipPlanex) STRCAT(msg, _T(", glClipPlanex"));
		if(!_glPointSizePointerOES) STRCAT(msg, _T(", glPointSizePointerOES"));
		if(!_glPointParameterfv) STRCAT(msg, _T(", glPointParameterfv"));
		if(!_glPointParameterxv) STRCAT(msg, _T(", glPointParameterxv"));
		if(!_glPointParameterf) STRCAT(msg, _T(", glPointParameterf"));
		if(!_glPointParameterx) STRCAT(msg, _T(", glPointParameterx"));
		if(!_glDrawTexfOES) STRCAT(msg, _T(", glDrawTexfOES"));
		if(!_glDrawTexxOES) STRCAT(msg, _T(", glDrawTexxOES"));
		if(!_glDrawTexiOES) STRCAT(msg, _T(", glDrawTexiOES"));
		if(!_glDrawTexsOES) STRCAT(msg, _T(", glDrawTexsOES"));
		if(!_glDrawTexfvOES) STRCAT(msg, _T(", glDrawTexfvOES"));
		if(!_glDrawTexxvOES) STRCAT(msg, _T(", glDrawTexxvOES"));
		if(!_glDrawTexivOES) STRCAT(msg, _T(", glDrawTexivOES"));
		if(!_glDrawTexsvOES) STRCAT(msg, _T(", glDrawTexsvOES"));
		if(!_glTexParameteri) STRCAT(msg, _T(", glTexParameteri"));
		if(!_glTexParameterfv) STRCAT(msg, _T(", glTexParameterfv"));
		if(!_glTexParameterxv) STRCAT(msg, _T(", glTexParameterxv"));
		if(!_glTexParameteriv) STRCAT(msg, _T(", glTexParameteriv"));
		if(!_eglGetError) STRCAT(msg, _T(", eglGetError"));
		if(!_eglGetDisplay) STRCAT(msg, _T(", eglGetDisplay"));
		if(!_eglInitialize) STRCAT(msg, _T(", eglInitialize"));
		if(!_eglTerminate) STRCAT(msg, _T(", eglTerminate"));
		if(!_eglQueryString) STRCAT(msg, _T(", eglQueryString"));
		if(!_eglGetConfigs) STRCAT(msg, _T(", eglGetConfigs"));
		if(!_eglChooseConfig) STRCAT(msg, _T(", eglChooseConfig"));
		if(!_eglGetConfigAttrib) STRCAT(msg, _T(", eglGetConfigAttrib"));
		if(!_eglCreateWindowSurface) STRCAT(msg, _T(", eglCreateWindowSurface"));
		if(!_eglCreatePbufferSurface) STRCAT(msg, _T(", eglCreatePbufferSurface"));
		if(!_eglCreatePixmapSurface) STRCAT(msg, _T(", eglCreatePixmapSurface"));
		if(!_eglDestroySurface) STRCAT(msg, _T(", eglDestroySurface"));
		if(!_eglQuerySurface) STRCAT(msg, _T(", eglQuerySurface"));
		if(!_eglSurfaceAttrib) STRCAT(msg, _T(", eglSurfaceAttrib"));
		if(!_eglBindTexImage) STRCAT(msg, _T(", eglBindTexImage"));
		if(!_eglReleaseTexImage) STRCAT(msg, _T(", eglReleaseTexImage"));
		if(!_eglSwapInterval) STRCAT(msg, _T(", eglSwapInterval"));
		if(!_eglCreateContext) STRCAT(msg, _T(", eglCreateContext"));
		if(!_eglDestroyContext) STRCAT(msg, _T(", eglDestroyContext"));
		if(!_eglMakeCurrent) STRCAT(msg, _T(", eglMakeCurrent"));
		if(!_eglGetCurrentContext) STRCAT(msg, _T(", eglGetCurrentContext"));
		if(!_eglGetCurrentSurface) STRCAT(msg, _T(", eglGetCurrentSurface"));
		if(!_eglGetCurrentDisplay) STRCAT(msg, _T(", eglGetCurrentDisplay"));
		if(!_eglQueryContext) STRCAT(msg, _T(", eglQueryContext"));
		if(!_eglWaitGL) STRCAT(msg, _T(", eglWaitGL"));
		if(!_eglWaitNative) STRCAT(msg, _T(", eglWaitNative"));
		if(!_eglSwapBuffers) STRCAT(msg, _T(", eglSwapBuffers"));
		if(!_eglCopyBuffers) STRCAT(msg, _T(", eglCopyBuffers"));

		if(STRLEN(msg)!=len0)
		{
			::MessageBox(NULL, msg, _T("ERROR"), MB_OK);

			FILE* fp = fopen("KlimtES_Report.txt", "w");
			if(fp)
			{
				int i,len = STRLEN(msg)+1;
				char* cMsg = new char[len];
				for(i=0; i<len; i++)
					cMsg[i] = (char)msg[i];

				fwrite(cMsg, 1, len, fp);
				delete cMsg;
				fclose(fp);
			}
		}
	}

	return true;
}
