

#include "../include/klesDefinitions.h"


typedef void (*_GL_ACTIVETEXTURE)(GLenum);
typedef void (*_GL_ALPHAFUNC)(GLenum, GLclampf);
typedef void (*_GL_ALPHAFUNCX)(GLenum, GLclampx);
typedef void (*_GL_BINDTEXTURE)(GLenum, GLuint);
typedef void (*_GL_BLENDFUNC)(GLenum, GLenum);
typedef void (*_GL_CLEAR)(GLbitfield);
typedef void (*_GL_CLEARCOLOR)(GLclampf, GLclampf, GLclampf, GLclampf);
typedef void (*_GL_CLEARCOLORX)(GLclampx, GLclampx, GLclampx, GLclampx);
typedef void (*_GL_CLEARDEPTHF)(GLclampf);
typedef void (*_GL_CLEARDEPTHX)(GLclampx);
typedef void (*_GL_CLEARSTENCIL)(GLint);
typedef void (*_GL_CLIENTACTIVETEXTURE)(GLenum);
typedef void (*_GL_COLOR4F)(GLfloat, GLfloat, GLfloat, GLfloat);
typedef void (*_GL_COLOR4X)(GLfixed, GLfixed, GLfixed, GLfixed);
typedef void (*_GL_COLORMASK)(GLboolean, GLboolean, GLboolean, GLboolean);
typedef void (*_GL_COLORPOINTER)(GLint, GLenum, GLsizei, const GLvoid*);
typedef void (*_GL_COMPRESSEDTEXIMAGE2D)(GLenum, GLint, GLenum, GLsizei, GLsizei, GLint, GLsizei, const GLvoid*);
typedef void (*_GL_COMPRESSEDTEXSUBIMAGE2D)(GLenum, GLint, GLint, GLint, GLsizei, GLsizei, GLenum, GLsizei, const GLvoid*);
typedef void (*_GL_COPYTEXIMAGE2D)(GLenum, GLint, GLenum, GLint, GLint, GLsizei, GLsizei, GLint);
typedef void (*_GL_COPYTEXSUBIMAGE2D)(GLenum, GLint, GLint, GLint, GLint, GLint, GLsizei, GLsizei);
typedef void (*_GL_CULLFACE)(GLenum);
typedef void (*_GL_DELETETEXTURES)(GLsizei, const GLuint*);
typedef void (*_GL_DEPTHFUNC)(GLenum);
typedef void (*_GL_DEPTHMASK)(GLboolean);
typedef void (*_GL_DEPTHRANGEF)(GLclampf, GLclampf);
typedef void (*_GL_DEPTHRANGEX)(GLclampx, GLclampx);
typedef void (*_GL_DISABLE)(GLenum);
typedef void (*_GL_DISABLECLIENTSTATE)(GLenum);
typedef void (*_GL_DRAWARRAYS)(GLenum, GLint, GLsizei);
typedef void (*_GL_DRAWELEMENTS)(GLenum mode, GLsizei count, GLenum type, const GLvoid* indices);
typedef void (*_GL_ENABLE)(GLenum cap);
typedef void (*_GL_ENABLECLIENTSTATE)(GLenum cap);
typedef void (*_GL_FINISH)(void);
typedef void (*_GL_FLUSH)(void);
typedef void (*_GL_FOGF)(GLenum pname, GLfloat param);
typedef void (*_GL_FOGFV)(GLenum pname, const GLfloat* params);
typedef void (*_GL_FOGX)(GLenum pname, GLfixed param);
typedef void (*_GL_FOGXV)(GLenum pname, const GLfixed* params);
typedef void (*_GL_FRONTFACE)(GLenum mode);
typedef void (*_GL_FRUSTUMF)(GLfloat left, GLfloat right, GLfloat bottom, GLfloat top, GLfloat near_val, GLfloat far_val);
typedef void (*_GL_FRUSTUMX)(GLfixed left, GLfixed right, GLfixed bottom, GLfixed top, GLfixed near_val, GLfixed far_val);
typedef void (*_GL_GENTEXTURES)(GLsizei n, GLuint* textures);
typedef GLenum (*_GL_GETERROR)(void);
typedef void (*_GL_GETINTEGERV)(GLenum pname, GLint* params);
typedef const GLubyte* (*_GL_GETSTRING)(GLenum name);
typedef void (*_GL_HINT)(GLenum target, GLenum mode);
typedef void (*_GL_LIGHTF)(GLenum light, GLenum pname, GLfloat param);
typedef void (*_GL_LIGHTFV)(GLenum light, GLenum pname, const GLfloat* params);
typedef void (*_GL_LIGHTX)(GLenum light, GLenum pname, GLfixed param);
typedef void (*_GL_LIGHTXV)(GLenum light, GLenum pname, const GLfixed* params);
typedef void (*_GL_LIGHTMODELF)(GLenum pname, GLfloat param);
typedef void (*_GL_LIGHTMODELFV)(GLenum pname, const GLfloat* params);
typedef void (*_GL_LIGHTMODELX)(GLenum pname, GLfixed param);
typedef void (*_GL_LIGHTMODELXV)(GLenum pname, const GLfixed* params);
typedef void (*_GL_LINEWIDTH)(GLfloat width);
typedef void (*_GL_LINEWIDTHX)(GLfixed width);
typedef void (*_GL_LOADIDENTITY)(void);
typedef void (*_GL_LOADMATRIXF)(const GLfloat* m);
typedef void (*_GL_LOADMATRIXX)(const GLfixed* m);
typedef void (*_GL_LOGICOP)(GLenum opcode);
typedef void (*_GL_MATERIALF)(GLenum face, GLenum pname, GLfloat param);
typedef void (*_GL_MATERIALFV)(GLenum face, GLenum pname, const GLfloat* params);
typedef void (*_GL_MATERIALX)(GLenum face, GLenum pname, GLfixed param);
typedef void (*_GL_MATERIALXV)(GLenum face, GLenum pname, const GLfixed* params);
typedef void (*_GL_MATRIXMODE)(GLenum mode);
typedef void (*_GL_MULTITEXCOORD4F)(GLenum target, GLfloat s, GLfloat t, GLfloat r, GLfloat q);
typedef void (*_GL_MULTITEXCOORD4X)(GLenum target, GLfixed s, GLfixed t, GLfixed r, GLfixed q);
typedef void (*_GL_MULTMATRIXF)(const GLfloat* m);
typedef void (*_GL_MULTMATRIXX)(const GLfixed* m);
typedef void (*_GL_NORMAL3F)(GLfloat nx, GLfloat ny, GLfloat nz);
typedef void (*_GL_NORMAL3X)(GLfixed nx, GLfixed ny, GLfixed nz);
typedef void (*_GL_NORMALPOINTER)(GLenum, GLsizei, const GLvoid*);
typedef void (*_GL_ORTHOF)(GLfloat left, GLfloat right, GLfloat bottom, GLfloat top, GLfloat near_val, GLfloat far_val);
typedef void (*_GL_ORTHOX)(GLfixed left, GLfixed right, GLfixed bottom, GLfixed top, GLfixed near_val, GLfixed far_val);
typedef void (*_GL_PIXELSTOREI)(GLenum pname, GLint param);
typedef void (*_GL_POINTSIZE)(GLfloat size);
typedef void (*_GL_POINTSIZEX)(GLfixed size);
typedef void (*_GL_POLYGONOFFSET)(GLfloat factor, GLfloat units);
typedef void (*_GL_POLYGONOFFSETX)(GLfixed factor, GLfixed units);
typedef void (*_GL_POPMATRIX)(void);
typedef void (*_GL_PUSHMATRIX)(void);
typedef void (*_GL_READPIXELS)(GLint x, GLint y, GLsizei width, GLsizei height, GLenum format, GLenum type, GLvoid* pixels);
typedef void (*_GL_ROTATEF)(GLfloat angle, GLfloat x, GLfloat y, GLfloat z);
typedef void (*_GL_ROTATEX)(GLfixed angle, GLfixed x, GLfixed y, GLfixed z);
typedef void (*_GL_SAMPLECOVERAGE)(GLclampf value, GLboolean invert);
typedef void (*_GL_SAMPLECOVERAGEX)(GLclampx value, GLboolean invert);
typedef void (*_GL_SCALEF)(GLfloat x, GLfloat y, GLfloat z);
typedef void (*_GL_SCALEX)(GLfixed x, GLfixed y, GLfixed z);
typedef void (*_GL_SCISSOR)(GLint x, GLint y, GLsizei width, GLsizei height);
typedef void (*_GL_SHADEMODEL)(GLenum mode);
typedef void (*_GL_STENCILFUNC)(GLenum func, GLint ref, GLuint mask);
typedef void (*_GL_STENCILMASK)(GLuint mask);
typedef void (*_GL_STENCILOP)(GLenum fail, GLenum zfail, GLenum zpass);
typedef void (*_GL_TEXCOORDPOINTER)(GLint size, GLenum type, GLsizei stride, const GLvoid* ptr);
typedef void (*_GL_TEXENVF)(GLenum target, GLenum pname, GLfloat param);
typedef void (*_GL_TEXENVFV)(GLenum target, GLenum pname, const GLfloat* params);
typedef void (*_GL_TEXENVX)(GLenum target, GLenum pname, GLfixed param);
typedef void (*_GL_TEXENVXV)(GLenum target, GLenum pname, const GLfixed* params);
typedef void (*_GL_TEXIMAGE2D)(GLenum target, GLint level, GLint internalFormat, GLsizei width, GLsizei height, GLint border, GLenum format, GLenum type, const GLvoid* pixels);
typedef void (*_GL_TEXPARAMETERF)(GLenum target, GLenum pname, GLfloat param);
typedef void (*_GL_TEXPARAMETERX)(GLenum target, GLenum pname, GLfixed param);
typedef void (*_GL_TEXSUBIMAGE2D)(GLenum target, GLint level, GLint xoffset, GLint yoffset, GLsizei width, GLsizei height, GLenum format, GLenum type, const GLvoid* pixels);
typedef void (*_GL_TRANSLATEF)(GLfloat x, GLfloat y, GLfloat z);
typedef void (*_GL_TRANSLATEX)(GLfixed x, GLfixed y, GLfixed z);
typedef void (*_GL_VERTEXPOINTER)(GLint size, GLenum type, GLsizei stride, const GLvoid* ptr);
typedef void (*_GL_VIEWPORT)(GLint x, GLint y, GLsizei width, GLsizei height);
typedef void (*_GL_BINDBUFFER)(GLenum target, GLuint buffer);
typedef void (*_GL_BUFFERDATA)(GLenum target, GLsizeiptr size, const GLvoid* data, GLenum usage);
typedef void (*_GL_BUFFERSUBDATA)(GLenum target, GLintptr offset, GLsizeiptr size, const GLvoid* data);
typedef void (*_GL_COLOR4UB)(GLubyte red, GLubyte green, GLubyte blue, GLubyte alpha);
typedef void (*_GL_CURRENTPALETTEMATRIXOES)(GLuint matrix);
typedef void (*_GL_DELETEBUFFERS)(GLsizei n, const GLuint* buffers);
typedef void (*_GL_GENBUFFERS)(GLsizei n, GLuint* buffers);
typedef void (*_GL_GETBOOLEANV)(GLenum pname, GLboolean* params);
typedef void (*_GL_GETBUFFERPARAMETERIV)(GLenum target, GLenum pname, GLint* params);
typedef void (*_GL_GETCLIPPLANEF)(GLenum plane, GLfloat* equation);
typedef void (*_GL_GETCLIPPLANEX)(GLenum plane, GLfixed* equation);
typedef void (*_GL_GETFLOATV)(GLenum pname, GLfloat* params);
typedef void (*_GL_GETFIXEDV)(GLenum pname, GLfixed* params);
typedef void (*_GL_GETLIGHTFV)(GLenum light, GLenum pname, GLfloat* params);
typedef void (*_GL_GETLIGHTXV)(GLenum light, GLenum pname, GLfixed* params);
typedef void (*_GL_GETMATERIALFV)(GLenum face, GLenum pname, GLfloat* params);
typedef void (*_GL_GETMATERIALXV)(GLenum face, GLenum pname, GLfixed* params);
typedef void (*_GL_GETPOINTERV)(GLenum pname, GLvoid** params);
typedef void (*_GL_GETTEXENVFV)(GLenum target, GLenum pname, GLfloat* params);
typedef void (*_GL_GETTEXENVIV)(GLenum target, GLenum pname, GLint* params);
typedef void (*_GL_GETTEXENVXV)(GLenum target, GLenum pname, GLfixed* params);
typedef void (*_GL_GETTEXPARAMETERIV)(GLenum target, GLenum pname, GLint* params);
typedef void (*_GL_GETTEXPARAMETERFV)(GLenum target, GLenum pname, GLfloat* params);
typedef void (*_GL_GETTEXPARAMETERXV)(GLenum target, GLenum pname, GLfixed* params);
typedef GLboolean (*_GL_ISENABLED)(GLenum cap);
typedef GLboolean (*_GL_ISTEXTURE)(GLuint texture);
typedef GLboolean (*_GL_ISBUFFER)(GLuint buffer);
typedef void (*_GL_LOADPALETTEFROMMODELVIEWMATRIXOES)(void);
typedef void (*_GL_MATRIXINDEXPOINTEROES)(GLint size, GLenum type, GLsizei stride, const GLvoid* pointer);
typedef void (*_GL_WEIGHTPOINTEROES)(GLint size, GLenum type, GLsizei stride, const GLvoid* pointer);
typedef void (*_GL_CLIPPLANEF)(GLenum plane, const GLfloat* equation);
typedef void (*_GL_CLIPPLANEX)(GLenum plane, const GLfixed* equation);
typedef void (*_GL_POINTSIZEPOINTEROES)(GLenum type, GLsizei stride, const GLvoid* pointer);
typedef void (*_GL_POINTPARAMETERFV)(GLenum pname, const GLfloat* params);
typedef void (*_GL_POINTPARAMETERXV)(GLenum pname, const GLfixed* params);
typedef void (*_GL_POINTPARAMETERF)(GLenum pname, GLfloat params);
typedef void (*_GL_POINTPARAMETERX)(GLenum pname, GLfixed params);
typedef void (*_GL_DRAWTEXFOES)(GLfloat sx, GLfloat sy, GLfloat sz, GLfloat sw, GLfloat sh);
typedef void (*_GL_DRAWTEXXOES)(GLfixed sx, GLfixed sy, GLfixed sz, GLfixed sw, GLfixed sh);
typedef void (*_GL_DRAWTEXIOES)(GLint sx, GLint sy, GLint sz, GLint sw, GLint sh);
typedef void (*_GL_DRAWTEXSOES)(GLshort sx, GLshort sy, GLshort sz, GLshort sw, GLshort sh);
typedef void (*_GL_DRAWTEXFVOES)(GLfloat* params);
typedef void (*_GL_DRAWTEXXVOES)(GLfixed* params);
typedef void (*_GL_DRAWTEXIVOES)(GLint* params);
typedef void (*_GL_DRAWTEXSVOES)(GLshort* params);
typedef void (*_GL_TEXPARAMETERI)(GLenum target, GLenum pname, GLint param);
typedef void (*_GL_TEXPARAMETERFV)(GLenum target, GLenum pname, const GLfloat* param);
typedef void (*_GL_TEXPARAMETERXV)(GLenum target, GLenum pname, const GLfixed* param);
typedef void (*_GL_TEXPARAMETERIV)(GLenum target, GLenum pname, const GLint* param);


typedef EGLint (*_EGL_GetError)(void);
typedef EGLDisplay  (*_EGL_GETDISPLAY)(NativeDisplayType displayID);
typedef EGLBoolean  (*_EGL_INITIALIZE)(EGLDisplay dpy, EGLint* major, EGLint* minor);
typedef EGLBoolean  (*_EGL_TERMINATE)(EGLDisplay dpy);
typedef const char* (*_EGL_QUERYSTRING)(EGLDisplay dpy, EGLint name);
typedef EGLBoolean  (*_EGL_GETCONFIGS)(EGLDisplay dpy, EGLConfig* configs, EGLint config_size, EGLint* num_config);
typedef EGLBoolean  (*_EGL_CHOOSECONFIG)(EGLDisplay dpy, const EGLint* attrib_list, EGLConfig* configs, EGLint config_size, EGLint* num_config);
typedef EGLBoolean  (*_EGL_GETCONFIGATTRIB)(EGLDisplay dpy, EGLConfig config, EGLint attribute, EGLint* value);
typedef EGLSurface  (*_EGL_CREATEWINDOWSURFACE)(EGLDisplay dpy, EGLConfig config, NativeWindowType win, const EGLint* attrib_list);
typedef EGLSurface  (*_EGL_CREATEPBUFFERSURFACE)(EGLDisplay dpy, EGLConfig config, const EGLint* attrib_list);
typedef EGLSurface  (*_EGL_CREATEPIXMAPSURFACE)(EGLDisplay dpy, EGLConfig config, NativePixmapType pixmap, const EGLint* attrib_list);
typedef EGLBoolean  (*_EGL_DESTROYSURFACE)(EGLDisplay dpy, EGLSurface surface);
typedef EGLBoolean  (*_EGL_QUERYSURFACE)(EGLDisplay dpy, EGLSurface surface, EGLint attribute, EGLint* value);
typedef EGLBoolean (*_EGL_SURFACEATTRIB)(EGLDisplay dpy, EGLSurface surface, EGLint attribute, EGLint value);
typedef EGLBoolean (*_EGL_BINDTEXIMAGE)(EGLDisplay dpy, EGLSurface surface, EGLint buffer);
typedef EGLBoolean (*_EGL_RELEASETEXIMAGE)(EGLDisplay dpy, EGLSurface surface, EGLint buffer);
typedef EGLBoolean  (*_EGL_SWAPINTERVAL)(EGLDisplay dpy, EGLint interval);
typedef EGLContext  (*_EGL_CREATECONTEXT)(EGLDisplay dpy, EGLConfig config, EGLContext share_list, const EGLint* attrib_list);
typedef EGLBoolean  (*_EGL_DESTROYCONTEXT)(EGLDisplay dpy, EGLContext ctx);
typedef EGLBoolean  (*_EGL_MAKECURRENT)(EGLDisplay dpy, EGLSurface draw, EGLSurface read, EGLContext ctx);
typedef EGLContext  (*_EGL_GETCURRENTCONTEXT)(void);
typedef EGLSurface  (*_EGL_GETCURRENTSURFACE)(EGLint readdraw);
typedef EGLDisplay  (*_EGL_GETCURRENTDISPLAY)(void);
typedef EGLBoolean  (*_EGL_QUERYCONTEXT)(EGLDisplay dpy, EGLContext ctx, EGLint attribute, EGLint* value);
typedef EGLBoolean  (*_EGL_WAITGL)(void);
typedef EGLBoolean  (*_EGL_WAITNATIVE)(EGLint engine);
typedef EGLBoolean  (*_EGL_SWAPBUFFERS)(EGLDisplay dpy, EGLSurface surface);
typedef EGLBoolean  (*_EGL_COPYBUFFERS)(EGLDisplay dpy, EGLSurface surface, NativePixmapType target);



// OGL-ES 1.0 functions
extern _GL_ACTIVETEXTURE _glActiveTexture;
extern _GL_ALPHAFUNC _glAlphaFunc;
extern _GL_ALPHAFUNCX _glAlphaFuncx;
extern _GL_BINDTEXTURE _glBindTexture;
extern _GL_BLENDFUNC _glBlendFunc;
extern _GL_CLEAR _glClear;
extern _GL_CLEARCOLOR _glClearColor;
extern _GL_CLEARCOLORX _glClearColorx;
extern _GL_CLEARDEPTHF _glClearDepthf;
extern _GL_CLEARDEPTHX _glClearDepthx;
extern _GL_CLEARSTENCIL _glClearStencil;
extern _GL_CLIENTACTIVETEXTURE _glClientActiveTexture;
extern _GL_COLOR4F _glColor4f;
extern _GL_COLOR4X _glColor4x;
extern _GL_COLORMASK _glColorMask;
extern _GL_COLORPOINTER _glColorPointer;
extern _GL_COMPRESSEDTEXIMAGE2D _glCompressedTexImage2D;
extern _GL_COMPRESSEDTEXSUBIMAGE2D _glCompressedTexSubImage2D;
extern _GL_COPYTEXIMAGE2D _glCopyTexImage2D;
extern _GL_COPYTEXSUBIMAGE2D _glCopyTexSubImage2D;
extern _GL_CULLFACE _glCullFace;
extern _GL_DELETETEXTURES _glDeleteTextures;
extern _GL_DEPTHFUNC _glDepthFunc;
extern _GL_DEPTHMASK _glDepthMask;
extern _GL_DEPTHRANGEF _glDepthRangef;
extern _GL_DEPTHRANGEX _glDepthRangex;
extern _GL_DISABLE _glDisable;
extern _GL_DISABLECLIENTSTATE _glDisableClientState;
extern _GL_DRAWARRAYS _glDrawArrays;
extern _GL_DRAWELEMENTS _glDrawElements;
extern _GL_ENABLE _glEnable;
extern _GL_ENABLECLIENTSTATE _glEnableClientState;
extern _GL_FINISH _glFinish;
extern _GL_FLUSH _glFlush;
extern _GL_FOGF _glFogf;
extern _GL_FOGFV _glFogfv;
extern _GL_FOGX _glFogx;
extern _GL_FOGXV _glFogxv;
extern _GL_FRONTFACE _glFrontFace;
extern _GL_FRUSTUMF _glFrustumf;
extern _GL_FRUSTUMX _glFrustumx;
extern _GL_GENTEXTURES _glGenTextures;
extern _GL_GETERROR _glGetError;
extern _GL_GETINTEGERV _glGetIntegerv;
extern _GL_GETSTRING _glGetString;
extern _GL_HINT _glHint;
extern _GL_LIGHTF _glLightf;
extern _GL_LIGHTFV _glLightfv;
extern _GL_LIGHTX _glLightx;
extern _GL_LIGHTXV _glLightxv;
extern _GL_LIGHTMODELF _glLightModelf;
extern _GL_LIGHTMODELFV _glLightModelfv;
extern _GL_LIGHTMODELX _glLightModelx;
extern _GL_LIGHTMODELXV _glLightModelxv;
extern _GL_LINEWIDTH _glLineWidth;
extern _GL_LINEWIDTHX _glLineWidthx;
extern _GL_LOADIDENTITY _glLoadIdentity;
extern _GL_LOADMATRIXF _glLoadMatrixf;
extern _GL_LOADMATRIXX _glLoadMatrixx;
extern _GL_LOGICOP _glLogicOp;
extern _GL_MATERIALF _glMaterialf;
extern _GL_MATERIALFV _glMaterialfv;
extern _GL_MATERIALX _glMaterialx;
extern _GL_MATERIALXV _glMaterialxv;
extern _GL_MATRIXMODE _glMatrixMode;
extern _GL_MULTITEXCOORD4F _glMultiTexCoord4f;
extern _GL_MULTITEXCOORD4X _glMultiTexCoord4x;
extern _GL_MULTMATRIXF _glMultMatrixf;
extern _GL_MULTMATRIXX _glMultMatrixx;
extern _GL_NORMAL3F _glNormal3f;
extern _GL_NORMAL3X _glNormal3x;
extern _GL_NORMALPOINTER _glNormalPointer;
extern _GL_ORTHOF _glOrthof;
extern _GL_ORTHOX _glOrthox;
extern _GL_PIXELSTOREI _glPixelStorei;
extern _GL_POINTSIZE _glPointSize;
extern _GL_POINTSIZEX _glPointSizex;
extern _GL_POLYGONOFFSET _glPolygonOffset;
extern _GL_POLYGONOFFSETX _glPolygonOffsetx;
extern _GL_POPMATRIX _glPopMatrix;
extern _GL_PUSHMATRIX _glPushMatrix;
extern _GL_READPIXELS _glReadPixels;
extern _GL_ROTATEF _glRotatef;
extern _GL_ROTATEX _glRotatex;
extern _GL_SAMPLECOVERAGE _glSampleCoverage;
extern _GL_SAMPLECOVERAGEX _glSampleCoveragex;
extern _GL_SCALEF _glScalef;
extern _GL_SCALEX _glScalex;
extern _GL_SCISSOR _glScissor;
extern _GL_SHADEMODEL _glShadeModel;
extern _GL_STENCILFUNC _glStencilFunc;
extern _GL_STENCILMASK _glStencilMask;
extern _GL_STENCILOP _glStencilOp;
extern _GL_TEXCOORDPOINTER _glTexCoordPointer;
extern _GL_TEXENVF _glTexEnvf;
extern _GL_TEXENVFV _glTexEnvfv;
extern _GL_TEXENVX _glTexEnvx;
extern _GL_TEXENVXV _glTexEnvxv;
extern _GL_TEXIMAGE2D _glTexImage2D;
extern _GL_TEXPARAMETERF _glTexParameterf;
extern _GL_TEXPARAMETERX _glTexParameterx;
extern _GL_TEXSUBIMAGE2D _glTexSubImage2D;
extern _GL_TRANSLATEF _glTranslatef;
extern _GL_TRANSLATEX _glTranslatex;
extern _GL_VERTEXPOINTER _glVertexPointer;
extern _GL_VIEWPORT _glViewport;

// OGL-ES 1.0 functions
extern _GL_BINDBUFFER _glBindBuffer;
extern _GL_BUFFERDATA _glBufferData;
extern _GL_BUFFERSUBDATA _glBufferSubData;
extern _GL_COLOR4UB _glColor4ub;
extern _GL_CURRENTPALETTEMATRIXOES _glCurrentPaletteMatrixOES;
extern _GL_DELETEBUFFERS _glDeleteBuffers;
extern _GL_GENBUFFERS _glGenBuffers;
extern _GL_GETBOOLEANV _glGetBooleanv;
extern _GL_GETBUFFERPARAMETERIV _glGetBufferParameteriv;
extern _GL_GETCLIPPLANEF _glGetClipPlanef;
extern _GL_GETCLIPPLANEX _glGetClipPlanex;
extern _GL_GETFLOATV _glGetFloatv;
extern _GL_GETFIXEDV _glGetFixedv;
extern _GL_GETLIGHTFV _glGetLightfv;
extern _GL_GETLIGHTXV _glGetLightxv;
extern _GL_GETMATERIALFV _glGetMaterialfv;
extern _GL_GETMATERIALXV _glGetMaterialxv;
extern _GL_GETPOINTERV _glGetPointerv;
extern _GL_GETTEXENVFV _glGetTexEnvfv;
extern _GL_GETTEXENVIV _glGetTexEnviv;
extern _GL_GETTEXENVXV _glGetTexEnvxv;
extern _GL_GETTEXPARAMETERIV _glGetTexParameteriv;
extern _GL_GETTEXPARAMETERFV _glGetTexParameterfv;
extern _GL_GETTEXPARAMETERXV _glGetTexParameterxv;
extern _GL_ISENABLED _glIsEnabled;
extern _GL_ISTEXTURE _glIsTexture;
extern _GL_ISBUFFER _glIsBuffer;
extern _GL_LOADPALETTEFROMMODELVIEWMATRIXOES _glLoadPaletteFromModelViewMatrixOES;
extern _GL_MATRIXINDEXPOINTEROES _glMatrixIndexPointerOES;
extern _GL_WEIGHTPOINTEROES _glWeightPointerOES;
extern _GL_CLIPPLANEF _glClipPlanef;
extern _GL_CLIPPLANEX _glClipPlanex;
extern _GL_POINTSIZEPOINTEROES _glPointSizePointerOES;
extern _GL_POINTPARAMETERFV _glPointParameterfv;
extern _GL_POINTPARAMETERXV _glPointParameterxv;
extern _GL_POINTPARAMETERF _glPointParameterf;
extern _GL_POINTPARAMETERX _glPointParameterx;
extern _GL_DRAWTEXFOES _glDrawTexfOES;
extern _GL_DRAWTEXXOES _glDrawTexxOES;
extern _GL_DRAWTEXIOES _glDrawTexiOES;
extern _GL_DRAWTEXSOES _glDrawTexsOES;
extern _GL_DRAWTEXFVOES _glDrawTexfvOES;
extern _GL_DRAWTEXXVOES _glDrawTexxvOES;
extern _GL_DRAWTEXIVOES _glDrawTexivOES;
extern _GL_DRAWTEXSVOES _glDrawTexsvOES;
extern _GL_TEXPARAMETERI _glTexParameteri;
extern _GL_TEXPARAMETERFV _glTexParameterfv;
extern _GL_TEXPARAMETERXV _glTexParameterxv;
extern _GL_TEXPARAMETERIV _glTexParameteriv;


extern _EGL_GetError _eglGetError;
extern _EGL_GETDISPLAY _eglGetDisplay;
extern _EGL_INITIALIZE _eglInitialize;
extern _EGL_TERMINATE _eglTerminate;
extern _EGL_QUERYSTRING _eglQueryString;
extern _EGL_GETCONFIGS _eglGetConfigs;
extern _EGL_CHOOSECONFIG _eglChooseConfig;
extern _EGL_GETCONFIGATTRIB _eglGetConfigAttrib;
extern _EGL_CREATEWINDOWSURFACE _eglCreateWindowSurface;
extern _EGL_CREATEPBUFFERSURFACE _eglCreatePbufferSurface;
extern _EGL_CREATEPIXMAPSURFACE _eglCreatePixmapSurface;
extern _EGL_DESTROYSURFACE _eglDestroySurface;
extern _EGL_QUERYSURFACE _eglQuerySurface;
extern _EGL_SURFACEATTRIB _eglSurfaceAttrib;
extern _EGL_BINDTEXIMAGE _eglBindTexImage;
extern _EGL_RELEASETEXIMAGE _eglReleaseTexImage;
extern _EGL_SWAPINTERVAL _eglSwapInterval;
extern _EGL_CREATECONTEXT _eglCreateContext;
extern _EGL_DESTROYCONTEXT _eglDestroyContext;
extern _EGL_MAKECURRENT _eglMakeCurrent;
extern _EGL_GETCURRENTCONTEXT _eglGetCurrentContext;
extern _EGL_GETCURRENTSURFACE _eglGetCurrentSurface;
extern _EGL_GETCURRENTDISPLAY _eglGetCurrentDisplay;
extern _EGL_QUERYCONTEXT _eglQueryContext;
extern _EGL_WAITGL _eglWaitGL;
extern _EGL_WAITNATIVE _eglWaitNative;
extern _EGL_SWAPBUFFERS _eglSwapBuffers;
extern _EGL_COPYBUFFERS _eglCopyBuffers;

bool bindGLESFunctions(bool nShowReport);
